class Artist < ActiveRecord::Base
  belongs_to :author
  has_many :original_pictures
  
  validates :name, :presence => true, :length => {:maximum => 30}
#  validates :default_license_id, :presence => true, :numericality => true, :existence => true
  
  def supply_default
    self.name = 'no name' if self.name.blank?
  end
  
  def self.find_by_author author
    Artist.find( :first, :conditions => ['author_id = ?', author.id])
  end
  
  def self.default_page_size
    25
  end
  
  def self.max_page_size
    100
  end
  
  def self.default_panel_size
    30
  end
  
  def self.max_panel_size
    200
  end
  
  def self.page prm = nil
    page = prm.to_i
    page = 1 if page < 1
    page
  end
  
  def self.page_size prm = self.default_page_size
    page_size = prm.to_i
    page_size = self.max_page_size if page_size > self.max_page_size
    page_size = self.default_page_size if page_size < 1
    page_size
  end
  
  def self.offset cnt, prm = nil
    offset = prm.to_i
    offset = cnt - 1 if offset >= cnt
    offset = cnt - offset.abs if offset < 0
    offset = 0 if offset < 0
    offset
  end
  
  def self.list opt = {}, page = 1, page_size = self.default_page_size
    opt.merge!(self.list_opt) unless opt[:include]
    opt.merge!({:order => 'updated_at desc', :limit => page_size, :offset => (page -1) * page_size})
    Artist.find(:all, opt)
  end
  
  def self.list_opt
    {:include => :author}
  end
  
  def self.list_json_opt
    {:include => :author}
  end
  
  def self.show aid, opt = {}
    a = Artist.find(aid, :include => self.show_include_opt(opt))
#    raise ActiveRecord::Forbidden unless c.visible?(au)
    a
  end
  
  def self.show_include_opt opt = {}
    res = [:author]
    res.push(opt[:include]) if opt[:include]
    res
  end
  
  def self.show_json_include_opt
    {:include => :author}
  end
  
  def self.visible_count
    Artist.count
  end
  
end
