#
class License < ActiveRecord::Base
  belongs_to :license_group
  belongs_to :system_picture
  
  validates :license_group_id, :presence => true, :numericality => true, :existence => true
  validates :name, :presence => true, :length => {:maximum => 50}
  validates :caption, :presence => true, :length => {:maximum => 30}
  validates :url, :presence => true, :length => {:maximum => 200}, :uniqueness => true, :url => true #{:allow_blank => true}
  validates :system_picture_id, :presence => true, :numericality => true, :existence => true
  
  def self.store name, attr
    r = License.replace_system_picture attr
    l = License.modify_object name, attr
    if r == false
      l.errors.add :base, 'system picture can not create'
    else
      l.save
    end
    l
  end
  
  def self.stores attrs, lg_id
    res = 0
    return 0 unless attrs.is_a?(Hash)
    attrs.each do |name, attr|
      attr["license_group_id"] = lg_id
      l = License.store name, attr
      res += 1 unless l.valid?
    end
    res
  end
  
  def self.list opt = {}
    opt.merge!(self.list_opt) unless opt[:include]
    opt.merge!({:order => 'name'})
    License.find(:all, opt)
  end
  
  def self.list_opt
    {:include => {:license_group => {}}}
  end
  
  def self.list_json_opt
    {:include => {:license_group => {}}}
  end
  
  def self.show rid, opt = {}
    r = License.find(rid, :include => self.show_include_opt(opt))
#    raise ActiveRecord::Forbidden unless c.visible?(au)
    r
  end
  
  def self.show_include_opt opt = {}
    res = [:license_group]
    res.push(opt[:include]) if opt[:include]
    res
  end
  
  def self.show_json_include_opt
    {:include => {:license_group => {}}}
  end
  
end
